local flourish = CreateFrame("Frame")
local flourishBar = CreateFrame("StatusBar", nil, MainMenuExpBar)
local flourishVer = "1.0"
flourishBar:SetFrameStrata(MainMenuExpBar:GetFrameStrata())
flourishBar:SetFrameLevel(MainMenuExpBar:GetFrameLevel())
flourishBar:SetWidth(MainMenuExpBar:GetWidth())
flourishBar:SetHeight(MainMenuExpBar:GetHeight())
flourishBar:SetPoint("CENTER", MainMenuExpBar, "CENTER", 0, 0)
flourishBar:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar")
flourishBar:SetMinMaxValues(0, UnitXPMax("player"))
flourishBar:SetValue(0)
local flourishBarFix = CreateFrame("StatusBar", nil, flourishBar)
flourishBarFix:SetFrameStrata(flourishBar:GetFrameStrata())
flourishBarFix:SetFrameLevel(flourishBar:GetFrameLevel())
flourishBarFix:SetWidth(MainMenuExpBar:GetWidth())
flourishBarFix:SetHeight(MainMenuExpBar:GetHeight())
flourishBarFix:SetPoint("CENTER", MainMenuExpBar, "CENTER", 0, 0)
flourishBarFix:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar")
flourishBarFix:SetMinMaxValues(0, UnitXPMax("player"))
flourishBarFix:SetValue(0)
flourish:SetScript("OnEvent", function(self, event, ...) if self[event] then return self[event](self, event, ...) end end)
flourish:RegisterEvent("ADDON_LOADED")
flourish:RegisterEvent("QUEST_LOG_UPDATE")
flourish:RegisterEvent("PLAYER_XP_UPDATE")
flourish:RegisterEvent("ZONE_CHANGED_NEW_AREA")
flourish:RegisterEvent("UNIT_PORTRAIT_UPDATE")

local flourishCheckBox = {}
local flourishQuestLogFrame = {}
local flourishOptionsShown = false
local flourishCheckedSaved = true
local flourishBEBCreated = false
local flourishBarBEB
local flourishDominosCreated = false
local flourishBarDominos
local flourishDominosXP
local flourishXparkyCreated = false
local flourishBarXparky
local flourishXPBarNoneCreated = false
local flourishXPBarNone
local flourishXPBarNoneTextures = {}
local flourishCreatedBoxes = {}
local flourishBackdrop = {
  -- path to the background texture
  bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", 
  -- path to the border texture
  edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
  -- true to repeat the background texture to fill the frame, false to scale it
  tile = true,
  -- size (width or height) of the square repeating background tiles (in pixels)
  tileSize = 12,
  -- thickness of edge segments and square size of edge corners (in pixels)
  edgeSize = 12,
  -- distance from the edges of the frame to those of the background texture (in pixels)
  insets = {
	left = 2,
	right = 2,
	top = 2,
	bottom = 2
  }
}

DEFAULT_CHAT_FRAME:AddMessage("|cFF4499FFFlourish v"..flourishVer.." Loaded")

function flourish_Dominos()
  if (IsAddOnLoaded("Dominos")) then
  if (not flourishDominosCreated) then
    flourishDominosXP = Dominos.Frame:Get("xp")
	if (flourishDominosXP) then
	  flourishBarDominos = CreateFrame("StatusBar", "flourishBarDominos", flourishDominosXP)
	  flourishBarDominos:SetFrameStrata(flourishDominosXP:GetFrameStrata())
	  flourishBarDominos:SetFrameLevel(flourishDominosXP:GetFrameLevel()+2)
	  flourishBarDominos:SetWidth(flourishDominosXP:GetWidth())
	  flourishBarDominos:SetHeight(flourishDominosXP:GetHeight())
	  flourishBarDominos:SetPoint("CENTER", flourishDominosXP, "CENTER", 0, 0)
	  flourishBarDominos:SetStatusBarTexture(flourishDominosXP.bg:GetTexture())
	  flourishBarDominos:SetMinMaxValues(0, UnitXPMax("player"))
	  flourishBarDominos:SetValue(0)
	  flourishDominosCreated = true
	end
  end
  end
end
function flourish_BEB()
  if (IsAddOnLoaded("BEB")) then
  if (not flourishBEBCreated) then
	flourishBarBEB = CreateFrame("StatusBar", nil, BEBBackground)
	flourishBarBEB:SetFrameStrata(BEBBackground:GetFrameStrata())
	flourishBarBEB:SetFrameLevel(BEBXpBar:GetFrameLevel())
	flourishBarBEB:SetWidth(BEBBackground:GetWidth())
	flourishBarBEB:SetHeight(BEBBackground:GetHeight())
	flourishBarBEB:SetPoint("CENTER", BEBBackground, "CENTER", 0, 0)
	flourishBarBEB:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar")
	flourishBarBEB:SetMinMaxValues(0, UnitXPMax("player"))
	flourishBarBEB:SetValue(0)
	flourishBEBCreated = true
  end
  end
end
function flourish_XPBarNone()
  if (IsAddOnLoaded("XPBarNone")) then
  if (not flourishXPBarNoneCreated) then
	flourishXPBarNone = CreateFrame("StatusBar", nil, XPBarNoneBackground)
	flourishXPBarNone:SetFrameStrata(XPBarNoneXPBar:GetFrameStrata())
	flourishXPBarNone:SetFrameLevel(XPBarNoneXPBar:GetFrameLevel())
	flourishXPBarNone:SetWidth(XPBarNoneBackground:GetWidth())
	flourishXPBarNone:SetHeight(XPBarNoneBackground:GetHeight())
	flourishXPBarNone:SetPoint("CENTER", XPBarNoneBackground, "CENTER", 0, 0)
	flourishXPBarNone:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar")
	flourishXPBarNone:SetMinMaxValues(0, UnitXPMax("player"))
	flourishXPBarNone:SetValue(0)
	flourishXPBarNoneCreated = true
	flourishXPBarNoneTextures["BantoBar"] = "Interface\\AddOns\\XPBarNone\\Textures\\bantobar"
    flourishXPBarNoneTextures["Charcoal"] = "Interface\\AddOns\\XPBarNone\\Textures\\charcoal"
	flourishXPBarNoneTextures["Glaze"] = "Interface\\AddOns\\XPBarNone\\Textures\\glaze"
	flourishXPBarNoneTextures["LiteStep"] = "Interface\\AddOns\\XPBarNone\\Textures\\litestep"
	flourishXPBarNoneTextures["Marble"] = "Interface\\AddOns\\XPBarNone\\Textures\\marble"
	flourishXPBarNoneTextures["Otravi"] = "Interface\\AddOns\\XPBarNone\\Textures\\otravi"
	flourishXPBarNoneTextures["Perl"] = "Interface\\AddOns\\XPBarNone\\Textures\\perl"
	flourishXPBarNoneTextures["Smooth"] = "Interface\\AddOns\\XPBarNone\\Textures\\smooth"
	flourishXPBarNoneTextures["Smooth v2"] = "Interface\\AddOns\\XPBarNone\\Textures\\smoothv2"
	flourishXPBarNoneTextures["Striped"] = "Interface\\AddOns\\XPBarNone\\Textures\\striped"
	flourishXPBarNoneTextures["Waves"] = "Interface\\AddOns\\XPBarNone\\Textures\\waves"
  end
  end
end
function flourish_Xparky()
  if (IsAddOnLoaded("Xparky")) then
  if (not flourishXparkyCreated) then
	flourishBarXparky = CreateFrame("StatusBar", nil, XparkyXPAnchor)
	flourishBarXparky:SetFrameStrata(XPBarXparky:GetFrameStrata())
	flourishBarXparky:SetFrameLevel(XPBarXparky:GetFrameLevel())
	flourishBarXparky:SetWidth(XPBarXparky:GetWidth()+RestBarXparky:GetWidth()+NoXPBarXparky:GetWidth())
	flourishBarXparky:SetHeight(XparkyXPAnchor:GetHeight())
	flourishBarXparky:SetPoint("CENTER", XparkyXPAnchor, "CENTER", 0, 0)
	flourishBarXparky:SetStatusBarTexture("Interface\\AddOns\\Xparky\\Textures\\texture.tga")
	flourishBarXparky:SetMinMaxValues(0, UnitXPMax("player"))
	flourishBarXparky:SetValue(0)
	flourishBarXparkySpark = CreateFrame("StatusBar", nil, flourishBarXparky)
	flourishBarXparkySpark:SetFrameStrata(flourishBarXparky:GetFrameStrata())
	flourishBarXparkySpark:SetFrameLevel(flourishBarXparky:GetFrameLevel()+1)
	flourishBarXparkySpark:SetPoint("LEFT", flourishBarXparky, "LEFT", -120, 0)
	flourishBarXparkySpark:SetWidth(128)
	flourishBarXparkySpark:SetHeight(flourishBarXparky:GetHeight()+13.5)
	flourishBarXparkySpark:SetStatusBarTexture("Interface\\AddOns\\Xparky\\Textures\\glow.tga")
	flourishBarXparkySpark:SetMinMaxValues(0, 1)
	flourishBarXparkySpark:SetValue(1)
	flourishXparkyCreated = true
  end
  end
end

SLASH_FLOURISH1 = '/flourish'
SlashCmdList["FLOURISH"] = function(msg, editbox)
 if msg == 'currentzone' then
  if (flourishOptions["zoneOnly"]) then
    flourishOptions["zoneOnly"] = false
    DEFAULT_CHAT_FRAME:AddMessage("|cFFAAAAAAFlourish Current Zone Only |cFFFF7777OFF")
	flourishZoneOption:SetChecked(false)
  else
    flourishOptions["zoneOnly"] = true
    DEFAULT_CHAT_FRAME:AddMessage("|cFFAAAAAAFlourish Current Zone Only |cFF77FF77ON")
	flourishZoneOption:SetChecked(true)
	flourish:ZONE_CHANGED_NEW_AREA()
  end
 else
  flourishOptionsShowHide()
  updateQuestXP("misc")
 end
end

function currentZoneOption()
  if (flourishZoneOption:GetChecked()) then
    flourishOptions["zoneOnly"] = true
	flourish:ZONE_CHANGED_NEW_AREA()
  else
    flourishOptions["zoneOnly"] = false
  end
end

function incompleteOption()
  if (flourishIncompleteOption:GetChecked()) then
    flourishOptions["includeIncomplete"] = true
	updateQuestXP("misc")
  else
    flourishOptions["includeIncomplete"] = false
	updateQuestXP("misc")
  end
end

function messageOption()
  if (flourishMessageOption:GetChecked()) then
    flourishOptions["displayMessage"] = true
	updateQuestXP("misc")
  else
    flourishOptions["displayMessage"] = false
	updateQuestXP("misc")
  end
end

function flourish:ADDON_LOADED(event, addon)
  if flourishOptions == nil then
    flourishOptions = {}
    flourishOptions["zoneOnly"] = false
    flourishOptions["includeIncomplete"] = false
    flourishOptions["displayMessage"] = true
  end
  if flourishChecked == nil then
    flourishChecked = {}
    flourishCheckedSaved = false
  end
  flourishVariables()
end

function flourish:QUEST_LOG_UPDATE(event, addon)
  flourishCreateBoxes()
  flourish_BEB()
  flourish_Dominos()
  flourish_XPBarNone()
  flourish_Xparky()
  updateQuestXP(event)
end

function flourish:PLAYER_XP_UPDATE(event, addon)
  flourishCreateBoxes()
  updateQuestXP(event)
end

function flourish:UNIT_PORTRAIT_UPDATE(event, addon)
  flourishCreateBoxes()
  updateQuestXP(event)
end

function flourish:ZONE_CHANGED_NEW_AREA(event, addon)
  if (flourishOptions["zoneOnly"]) then
    local o = 1
	local curHeader = 1
    while GetQuestLogTitle(o) do
      local questLogTitleText, level, questTag, suggestedGroup, isHeader, isCollapsed, isComplete, isDaily, questID = GetQuestLogTitle(o)
      if ( isHeader ) then
	    if (questLogTitleText == GetZoneText()) then
		  flourishCheckBox[o]:SetChecked(true)
		else
		  flourishCheckBox[o]:SetChecked(false)
		end
      end
      o = o + 1
    end
    updateSection()
  end
end

function updateQuestXP(event)
  if (flourishOnceCalled) then
    local i = 1
	local lastHeader = 1
	local allChecked = false
    local currentQuestXPTotal = 0
	local flourishLastSelected = GetQuestLogSelection();
    while GetQuestLogTitle(i) do
      local questLogTitleText, level, questTag, suggestedGroup, isHeader, isCollapsed, isComplete, isDaily, questID = GetQuestLogTitle(i)
	  if (flourishOptions["includeIncomplete"]) then
	    isComplete = true
	  end
	  if (flourishCheckBox[i]:GetChecked()) then
	    flourishChecked[i] = true
	  else
	    flourishChecked[i] = false
	  end
      if ( not isHeader ) then
	    SelectQuestLogEntry(i)
	    if (flourishCheckBox[i]:GetChecked()) then
		  if (isComplete) then
	        currentQuestXPTotal = currentQuestXPTotal + GetQuestLogRewardXP()
		  end
	  	else
		  allChecked = false
		  flourishCheckBox[lastHeader]:SetChecked(false)
		end
	  else
		if (allChecked) then
		  flourishCheckBox[lastHeader]:SetChecked(true)
		end
		allChecked = true
	    lastHeader = i
      end
      i = i + 1
    end
	SelectQuestLogEntry(flourishLastSelected)
	if (allChecked) then
	  flourishCheckBox[lastHeader]:SetChecked(true)
    end
    local currXP = UnitXP("player")+currentQuestXPTotal
    local nextXP = UnitXPMax("player")
	if (currentQuestXPTotal == 0) then
	  currXP = 0
	end
    flourishBar:SetStatusBarColor(1.0, 0.75, 0.0, 0.5)
    if currXP > nextXP then
      PlaySound("Deathbind Sound")
	  if (flourishOptions["displayMessage"] and event == "QUEST_LOG_UPDATE") then
	    UIErrorsFrame:AddMessage("|cFF336699Flourish - |cFFC0FF00LEVEL UP |cFF336699- |cFFFFC000"..currentQuestXPTotal.." QXP")
      end
	  flourishBar:SetStatusBarColor(0.75, 1.0, 0.0, 0.5)
    else
	  if (flourishOptions["displayMessage"] and event == "QUEST_LOG_UPDATE") then
	    UIErrorsFrame:AddMessage("|cFF336699Flourish - |cFFFFC000"..currentQuestXPTotal.." QXP")
	  end
	end
    flourishBar:SetFrameStrata(MainMenuExpBar:GetFrameStrata())
    flourishBar:SetFrameLevel(MainMenuExpBar:GetFrameLevel())
    flourishBar:SetMinMaxValues(min(0, currXP), nextXP)
    flourishBar:SetValue(currXP)
    flourishBarFix:SetStatusBarColor(0.0, 0.39, 0.88, 1.0)
	local exhaustionStateID, exhaustionStateName, exhaustionStateMultiplier;
	exhaustionStateID, exhaustionStateName, exhaustionStateMultiplier = GetRestState();
	if (exhaustionStateID == 2) then
	  flourishBarFix:SetStatusBarColor(0.58, 0.0, 0.55, 1.0)
	end
    flourishBarFix:SetFrameStrata(MainMenuExpBar:GetFrameStrata())
    flourishBarFix:SetFrameLevel(MainMenuExpBar:GetFrameLevel())
    flourishBarFix:SetMinMaxValues(min(0, UnitXP("player")), nextXP)
    flourishBarFix:SetValue(UnitXP("player"))
	if (flourishBEBCreated) then
	  flourishBarBEB:SetStatusBarColor(1.0, 0.75, 0.0, 0.5)
      if currXP > nextXP then
        flourishBarBEB:SetStatusBarColor(0.75, 1.0, 0.0, 0.5)
      end
	  flourishBarBEB:SetFrameStrata(BEBBackground:GetFrameStrata())
	  flourishBarBEB:SetFrameLevel(BEBXpBar:GetFrameLevel())
      flourishBarBEB:SetMinMaxValues(min(0, currXP), nextXP)
      flourishBarBEB:SetValue(currXP)
	  flourishBarBEB:SetWidth(BEBBackground:GetWidth())
	  flourishBarBEB:SetHeight(BEBBackground:GetHeight())
	  flourishBarBEB:SetStatusBarTexture(BEB.TexturePath(BEBCharSettings.BEBXpBar.texture))
	end
	if (flourishDominosCreated) then
	  flourishBarDominos:SetStatusBarColor(1.0, 0.75, 0.0, 0.5)
      if currXP > nextXP then
        flourishBarDominos:SetStatusBarColor(0.75, 1.0, 0.0, 0.5)
      end
	  flourishBarDominos:SetFrameStrata(flourishDominosXP:GetFrameStrata())
	  flourishBarDominos:SetFrameLevel(flourishDominosXP:GetFrameLevel()+2)
      flourishBarDominos:SetMinMaxValues(min(0, currXP), nextXP)
      flourishBarDominos:SetValue(currXP)
	  flourishBarDominos:SetWidth(flourishDominosXP:GetWidth())
	  flourishBarDominos:SetHeight(flourishDominosXP:GetHeight())
	  flourishBarDominos:SetStatusBarTexture(flourishDominosXP.bg:GetTexture())
	end
	if (flourishXPBarNoneCreated) then
	  flourishXPBarNone:SetStatusBarColor(1.0, 0.75, 0.0, 0.5)
      if currXP > nextXP then
        flourishXPBarNone:SetStatusBarColor(0.75, 1.0, 0.0, 0.5)
      end
	  flourishXPBarNone:SetFrameStrata(XPBarNoneXPBar:GetFrameStrata())
	  flourishXPBarNone:SetFrameLevel(XPBarNoneXPBar:GetFrameLevel())
      flourishXPBarNone:SetMinMaxValues(min(0, currXP), nextXP)
      flourishXPBarNone:SetValue(currXP)
	  flourishXPBarNone:SetWidth(XPBarNoneBackground:GetWidth())
	  flourishXPBarNone:SetHeight(XPBarNoneBackground:GetHeight())
	  flourishXPBarNone:SetStatusBarTexture(flourishXPBarNoneTextures[XPBarNone.db.profile.general.texture])
	end
	if (flourishXparkyCreated) then
	  flourishBarXparky:SetStatusBarColor(1.0, 0.75, 0.0, 0.5)
	  flourishBarXparkySpark:SetStatusBarColor(1.0, 0.75, 0.0, 0.5)
      if currXP > nextXP then
        flourishBarXparky:SetStatusBarColor(0.75, 1.0, 0.0, 0.5)
        flourishBarXparkySpark:SetStatusBarColor(0.75, 1.0, 0.0, 0.5)
      end
	  if(Xparky.db.profile.ShowShadow) then
	    flourishXparkyShadow = 2.5
	  else
	    flourishXparkyShadow = 0
	  end
	  flourishBarXparky:SetPoint("CENTER", XparkyXPAnchor, "CENTER", 0, flourishXparkyShadow)
      flourishBarXparky:SetMinMaxValues(min(0, currXP), nextXP)
      flourishBarXparky:SetValue(currXP)
	  flourishBarXparky:SetWidth(XPBarXparky:GetWidth()+RestBarXparky:GetWidth()+NoXPBarXparky:GetWidth())
	  flourishBarXparky:SetHeight(XPBarXparky:GetHeight())
	  flourishXparkyMinValue, flourishXparkyMaxValue = flourishBarXparky:GetMinMaxValues()
	  flourishXparkyOffset = ((flourishBarXparky:GetValue()/flourishXparkyMaxValue)*flourishBarXparky:GetWidth())-120
	  flourishBarXparkySpark:SetHeight(flourishBarXparky:GetHeight()+12)
	  flourishBarXparkySpark:SetPoint("LEFT", flourishBarXparky, "LEFT", flourishXparkyOffset, 0)
	  flourishBarXparky:SetFrameStrata(XPBarXparky:GetFrameStrata())
	  flourishBarXparky:SetFrameLevel(XPBarXparky:GetFrameLevel())
	  flourishBarXparkySpark:SetFrameStrata(flourishBarXparky:GetFrameStrata())
	  flourishBarXparkySpark:SetFrameLevel(flourishBarXparky:GetFrameLevel()+1)
	  if (currXP == 0) then
	    flourishBarXparky:Hide()
	    flourishBarXparkySpark:Hide()
      else
	    flourishBarXparky:Show()
	    flourishBarXparkySpark:Show()
	  end
	end
  end
end

function flourishSetChecked()
  local k = 1
  while GetQuestLogTitle(k) do
    if (flourishChecked[k]) then
	  flourishCheckBox[k]:SetChecked(true)
	else
	  flourishCheckBox[k]:SetChecked(false)
	end
	k = k + 1
  end
  if (flourishOptions["zoneOnly"]) then
    flourishZoneOption:SetChecked(true)
  end
  if (flourishOptions["includeIncomplete"]) then
    flourishIncompleteOption:SetChecked(true)
  end
  if (flourishOptions["displayMessage"]) then
    flourishMessageOption:SetChecked(true)
  end
end

function updateSection()
    local p = 1
	local curHeader = 1
    while GetQuestLogTitle(p) do
      local questLogTitleText, level, questTag, suggestedGroup, isHeader, isCollapsed, isComplete, isDaily, questID = GetQuestLogTitle(p)
      if ( not isHeader ) then
	    if (flourishCheckBox[curHeader]:GetChecked()) then
		  flourishCheckBox[p]:SetChecked(true)
	  	else
		  flourishCheckBox[p]:SetChecked(false)
		end
	  else
	    curHeader = p
      end
	  if (flourishCheckBox[p]:GetChecked()) then
	    flourishChecked[p] = true
	  else
	    flourishChecked[p] = false
	  end
      p = p + 1
    end
  updateQuestXP("misc")
end

function flourishCreateBoxes()
  if (IsAddOnLoaded("UberQuest")) then
    flourishUberQuestVariables()
	  local n = 1
	  while GetQuestLogTitle(n) do
		local questTitle, level, questTag, suggestedGroup, isHeader, isCollapsed, isComplete, isDaily, questID = GetQuestLogTitle(n)
		if ( not isHeader ) then
		  if (not flourishCreatedBoxes[n]) then
			flourishCheckBox[n] = CreateFrame("CheckButton","flourishCheckBox"..n, flourishQuestLogFrame[n], "UICheckButtonTemplate")
			flourishCheckBox[n]:SetChecked(true)
		  end
		  flourishCheckBox[n]:SetScript("onClick", updateQuestXP)
		  flourishCheckBox[n]:ClearAllPoints()
		  flourishCheckBox[n]:SetPoint("Left",3,0)
		  flourishCreatedBoxes[n] = "quest"
		else
		  if (not flourishCreatedBoxes[n]) then
			flourishCheckBox[n] = CreateFrame("CheckButton","flourishCheckBox"..n, flourishQuestLogFrame[n], "UICheckButtonTemplate")
			flourishCheckBox[n]:SetChecked(true)
		  end
		  flourishCheckBox[n]:SetScript("onClick", updateSection)
		  flourishCheckBox[n]:ClearAllPoints()
		  flourishCheckBox[n]:SetPoint("Right",20,0)
		  flourishCreatedBoxes[n] = "header"
		end
	      flourishCheckBox[n]:SetBackdrop(flourishBackdrop)
		  flourishCheckBox[n]:SetWidth(16)
		  flourishCheckBox[n]:SetHeight(16)
	      flourishCheckBox[n]:SetBackdropBorderColor(0.2, 0.4, 0.7)
	      flourishCheckBox[n]:SetBackdropColor(0.2, 0.4, 0.7)
		n = n + 1
	  end
  elseif (IsAddOnLoaded("QuestGuru")) then
	flourishQuestGuruVariables()
	  local n = 1
	  while GetQuestLogTitle(n) do
		local questTitle, level, questTag, suggestedGroup, isHeader, isCollapsed, isComplete, isDaily, questID = GetQuestLogTitle(n)
		if ( not isHeader ) then
		  if (not flourishCreatedBoxes[n]) then
			flourishCheckBox[n] = CreateFrame("CheckButton","flourishCheckBox"..n, flourishQuestLogFrame[n], "UICheckButtonTemplate")
			flourishCheckBox[n]:SetChecked(true)
		  end
		  flourishCheckBox[n]:SetScript("onClick", updateQuestXP)
		  flourishCheckBox[n]:ClearAllPoints()
		  flourishCheckBox[n]:SetPoint("Left",0,0)
		  flourishCreatedBoxes[n] = "quest"
		else
		  if (not flourishCreatedBoxes[n]) then
			flourishCheckBox[n] = CreateFrame("CheckButton","flourishCheckBox"..n, flourishQuestLogFrame[n], "UICheckButtonTemplate")
			flourishCheckBox[n]:SetChecked(true)
		  end
		  flourishCheckBox[n]:SetScript("onClick", updateSection)
		  flourishCheckBox[n]:ClearAllPoints()
		  flourishCheckBox[n]:SetPoint("Right",30,0)
		  flourishCreatedBoxes[n] = "header"
		end
	      flourishCheckBox[n]:SetBackdrop(flourishBackdrop)
		  flourishCheckBox[n]:SetWidth(16)
		  flourishCheckBox[n]:SetHeight(16)
	      flourishCheckBox[n]:SetBackdropBorderColor(0.2, 0.4, 0.7)
	      flourishCheckBox[n]:SetBackdropColor(0.2, 0.4, 0.7)
		n = n + 1
	  end
  else
    flourishVariables()
	  local n = 1
	  while GetQuestLogTitle(n) do
		local questTitle, level, questTag, suggestedGroup, isHeader, isCollapsed, isComplete, isDaily, questID = GetQuestLogTitle(n)
		if ( not isHeader ) then
		  if (not flourishCreatedBoxes[n]) then
			flourishCheckBox[n] = CreateFrame("CheckButton","flourishCheckBox"..n, flourishQuestLogFrame[n], "UICheckButtonTemplate")
			flourishCheckBox[n]:SetChecked(true)
		  end
		  flourishCheckBox[n]:SetScript("onClick", updateQuestXP)
		  flourishCheckBox[n]:ClearAllPoints()
		  flourishCheckBox[n]:SetPoint("Left",5,0)
		  flourishCreatedBoxes[n] = "quest"
		else
		  if (not flourishCreatedBoxes[n]) then
			flourishCheckBox[n] = CreateFrame("CheckButton","flourishCheckBox"..n, flourishQuestLogFrame[n], "UICheckButtonTemplate")
			flourishCheckBox[n]:SetChecked(true)
		  end
			flourishCheckBox[n]:SetScript("onClick", updateSection)
		  flourishCheckBox[n]:ClearAllPoints()
		  flourishCheckBox[n]:SetPoint("Right",0,0)
		  flourishCreatedBoxes[n] = "header"
		end
	      flourishCheckBox[n]:SetBackdrop(flourishBackdrop)
		  flourishCheckBox[n]:SetWidth(16)
		  flourishCheckBox[n]:SetHeight(16)
	      flourishCheckBox[n]:SetBackdropBorderColor(0.2, 0.4, 0.7)
	      flourishCheckBox[n]:SetBackdropColor(0.2, 0.4, 0.7)
		n = n + 1
	  end
  end
  flourish:ZONE_CHANGED_NEW_AREA()
  -- flourish options frane
  if (not flourishOnceCalled) then
    -- create the quest log button
	if (IsAddOnLoaded("UberQuest")) then
      flourishQuestLogFrame = CreateFrame("Frame","flourishQuestLogFrame", UberQuest_List, "OptionsBoxTemplate")
      flourishQuestLogFrame:SetPoint("TOPLEFT",58,6)
	elseif (IsAddOnLoaded("QuestGuru")) then
      flourishQuestLogFrame = CreateFrame("Frame","flourishQuestLogFrame", QuestGuru_QuestLogFrame, "OptionsBoxTemplate")
      flourishQuestLogFrame:SetPoint("TOPLEFT",10,10)
	else
      flourishQuestLogFrame = CreateFrame("Frame","flourishQuestLogFrame", QuestLogFrame, "OptionsBoxTemplate")
      flourishQuestLogFrame:SetPoint("TOPLEFT",58,6)
    end
	flourishQuestLogFrame:SetWidth(60)
    flourishQuestLogFrame:SetHeight(22)
	flourishQuestLogFrame:SetFrameStrata("BACKGROUND")
	flourishQuestLogFrame:SetBackdrop(flourishBackdrop)
	flourishQuestLogFrame:SetBackdropBorderColor(0.2, 0.4, 0.7)
	flourishQuestLogFrame:SetBackdropColor(0.2, 0.2, 0.2)
	-- create an invisible button for the user to click to collapse and expand the options frame
	flourishOptionsButton = CreateFrame("Button", "flourishOptionsButton", flourishQuestLogFrame)
	flourishOptionsButton:SetWidth(45)
    flourishOptionsButton:SetHeight(16)
    flourishOptionsButton:SetPoint("Left",5,1)
	flourishOptionsButton:RegisterForClicks("AnyUp")
	flourishOptionsButton:SetFrameStrata("HIGH")
	flourishOptionsButton:SetScript("OnMouseUp", flourishOptionsShowHide)
	flourishOptionsButton:SetScript("OnEnter", flourishLabelHighlightOn)
	flourishOptionsButton:SetScript("OnLeave", flourishLabelHighlightOff)
	flourishQuestLogLabel = flourishQuestLogFrame:CreateFontString("flourishZoneText", flourishQuestLogFrame:GetFrameStrata())
    flourishQuestLogLabel:SetPoint("Left",5,1)
	flourishQuestLogLabel:SetFontObject("GameFontNormal")
	flourishQuestLogLabel:SetText("|cFF336699Flourish")
    -- create the options frame
    flourishOptionsFrame = CreateFrame("Frame", "flourishOptionsFrame", UIParent, "OptionsBoxTemplate")
    flourishOptionsFrame:SetPoint("CENTER",0,0)
	flourishOptionsFrame:SetWidth(200)
    flourishOptionsFrame:SetHeight(115)
	flourishOptionsFrame:SetFrameStrata("HIGH")
	flourishOptionsFrame:SetBackdrop(flourishBackdrop)
	flourishOptionsFrame:SetBackdropBorderColor(0.2, 0.4, 0.7)
	flourishOptionsFrame:SetBackdropColor(0.2, 0.25, 0.3)
    flourishOptionsFrame:EnableMouse(true)
	flourishOptionsFrame:SetClampedToScreen(true)
    flourishOptionsTitle = flourishOptionsFrame:CreateTitleRegion()
    flourishOptionsTitle:SetAllPoints()
	-- create a title for the options frame
	flourishOptionsLabel = flourishOptionsFrame:CreateFontString("flourishOptionsLabel", "HIGH")
    flourishOptionsLabel:SetPoint("TOP",0,-5)
	flourishOptionsLabel:SetFontObject("GameFontNormal")
	flourishOptionsLabel:SetText("|cFF4499FFFlourish v"..flourishVer.." Options")
	-- create an invisible button for the user to click to collapse and expand the options frame
	flourishCloseButton = CreateFrame("Button", "flourishCloseButton", flourishOptionsFrame)
	flourishCloseButton:SetWidth(45)
    flourishCloseButton:SetHeight(16)
    flourishCloseButton:SetPoint("BOTTOM",0,5)
	flourishCloseButton:RegisterForClicks("AnyUp")
	flourishCloseButton:SetFrameStrata("HIGH")
	flourishCloseButton:SetScript("OnMouseUp", flourishOptionsShowHide)
	flourishCloseButton:SetScript("OnEnter", flourishCloseHighlightOn)
	flourishCloseButton:SetScript("OnLeave", flourishCloseHighlightOff)
	flourishCloseLabel = flourishOptionsFrame:CreateFontString("flourishCloseLabel", "HIGH")
    flourishCloseLabel:SetPoint("Bottom",0,5)
	flourishCloseLabel:SetFontObject("GameFontNormal")
	flourishCloseLabel:SetText("|cFF996633Close")
	-- flourish zone options
    flourishZoneOption = CreateFrame("CheckButton","flourishZoneOption", flourishOptionsFrame, "UICheckButtonTemplate")
    flourishZoneOption:SetScript("onClick", currentZoneOption)
    flourishZoneOption:SetPoint("TOPLEFT",20,-25)
	flourishZoneOption:SetWidth(20)
	flourishZoneOption:SetHeight(20)
	flourishZoneText = flourishZoneOption:CreateFontString("flourishZoneText", flourishOptionsFrame:GetFrameStrata())
    flourishZoneText:SetPoint("Left",20,0)
	flourishZoneText:SetFontObject("GameFontNormal")
	flourishZoneText:SetTextHeight(12)
	flourishZoneText:SetText("Only Current Zone")
	-- flourish incomplete options
    flourishIncompleteOption = CreateFrame("CheckButton","flourishIncompleteOption", flourishOptionsFrame, "UICheckButtonTemplate")
    flourishIncompleteOption:SetScript("onClick", incompleteOption)
    flourishIncompleteOption:SetPoint("TOPLEFT",20,-50)
	flourishIncompleteOption:SetWidth(20)
	flourishIncompleteOption:SetHeight(20)
	flourishIncompleteText = flourishIncompleteOption:CreateFontString("flourishIncompleteText", flourishOptionsFrame:GetFrameStrata())
    flourishIncompleteText:SetPoint("Left",20,0)
	flourishIncompleteText:SetFontObject("GameFontNormal")
	flourishIncompleteText:SetTextHeight(12)
	flourishIncompleteText:SetText("Include Incomplete Quests")
	-- flourish incomplete options
    flourishMessageOption = CreateFrame("CheckButton","flourishMessageOption", flourishOptionsFrame, "UICheckButtonTemplate")
    flourishMessageOption:SetScript("onClick", messageOption)
    flourishMessageOption:SetPoint("TOPLEFT",20,-75)
	flourishMessageOption:SetWidth(20)
	flourishMessageOption:SetHeight(20)
	flourishMessageOption:SetChecked(true)
	flourishMessageText = flourishMessageOption:CreateFontString("flourishMessageText", flourishOptionsFrame:GetFrameStrata())
    flourishMessageText:SetPoint("Left",20,0)
	flourishMessageText:SetFontObject("GameFontNormal")
	flourishMessageText:SetText("Display Quest Messages")
	-- collapse options frame
	-- set flourish variables as called
    flourishOnceCalled = true
	flourishOptionsFrame:Hide()
    -- load saved variables and restore previously checked quests
	if (flourishCheckedSaved) then
	  flourishSetChecked()
	end
  end
end

function flourishCloseHighlightOn()
  flourishCloseLabel:SetText("|cFFFF9944Close")
end

function flourishCloseHighlightOff()
  flourishCloseLabel:SetText("|cFF996633Close")
end

function flourishLabelHighlightOn()
  flourishQuestLogLabel:SetText("|cFF4499FFFlourish")
end

function flourishLabelHighlightOff()
  flourishQuestLogLabel:SetText("|cFF336699Flourish")
end

function flourishOptionsShowHide()
  if (flourishOptionsShown) then
	flourishOptionsShown = false
	flourishOptionsFrame:Hide()
  else
    flourishOptionsShown = true
	flourishOptionsFrame:Show()
  end
end

function flourishVariables()
  flourishQuestLogFrame[1] = QuestLogScrollFrameButton1
  flourishQuestLogFrame[2] = QuestLogScrollFrameButton2
  flourishQuestLogFrame[3] = QuestLogScrollFrameButton3
  flourishQuestLogFrame[4] = QuestLogScrollFrameButton4
  flourishQuestLogFrame[5] = QuestLogScrollFrameButton5
  flourishQuestLogFrame[6] = QuestLogScrollFrameButton6
  flourishQuestLogFrame[7] = QuestLogScrollFrameButton7
  flourishQuestLogFrame[8] = QuestLogScrollFrameButton8
  flourishQuestLogFrame[9] = QuestLogScrollFrameButton9
  flourishQuestLogFrame[10] = QuestLogScrollFrameButton10
  flourishQuestLogFrame[11] = QuestLogScrollFrameButton11
  flourishQuestLogFrame[12] = QuestLogScrollFrameButton12
  flourishQuestLogFrame[13] = QuestLogScrollFrameButton13
  flourishQuestLogFrame[14] = QuestLogScrollFrameButton14
  flourishQuestLogFrame[15] = QuestLogScrollFrameButton15
  flourishQuestLogFrame[16] = QuestLogScrollFrameButton16
  flourishQuestLogFrame[17] = QuestLogScrollFrameButton17
  flourishQuestLogFrame[18] = QuestLogScrollFrameButton18
  flourishQuestLogFrame[19] = QuestLogScrollFrameButton19
  flourishQuestLogFrame[20] = QuestLogScrollFrameButton20
  flourishQuestLogFrame[21] = QuestLogScrollFrameButton21
  flourishQuestLogFrame[22] = QuestLogScrollFrameButton22
  flourishQuestLogFrame[23] = QuestLogScrollFrameButton23
  flourishQuestLogFrame[24] = QuestLogScrollFrameButton24
  flourishQuestLogFrame[25] = QuestLogScrollFrameButton25
  flourishQuestLogFrame[26] = QuestLogScrollFrameButton26
  flourishQuestLogFrame[27] = QuestLogScrollFrameButton27
  flourishQuestLogFrame[28] = QuestLogScrollFrameButton28
  flourishQuestLogFrame[29] = QuestLogScrollFrameButton29
  flourishQuestLogFrame[30] = QuestLogScrollFrameButton30
  flourishQuestLogFrame[31] = QuestLogScrollFrameButton31
  flourishQuestLogFrame[32] = QuestLogScrollFrameButton32
  flourishQuestLogFrame[33] = QuestLogScrollFrameButton33
  flourishQuestLogFrame[34] = QuestLogScrollFrameButton34
  flourishQuestLogFrame[35] = QuestLogScrollFrameButton35
  flourishQuestLogFrame[36] = QuestLogScrollFrameButton36
  flourishQuestLogFrame[37] = QuestLogScrollFrameButton37
  flourishQuestLogFrame[38] = QuestLogScrollFrameButton38
  flourishQuestLogFrame[39] = QuestLogScrollFrameButton39
  flourishQuestLogFrame[40] = QuestLogScrollFrameButton40
  flourishQuestLogFrame[41] = QuestLogScrollFrameButton41
  flourishQuestLogFrame[42] = QuestLogScrollFrameButton42
  flourishQuestLogFrame[43] = QuestLogScrollFrameButton43
  flourishQuestLogFrame[44] = QuestLogScrollFrameButton44
  flourishQuestLogFrame[45] = QuestLogScrollFrameButton45
  flourishQuestLogFrame[46] = QuestLogScrollFrameButton46
  flourishQuestLogFrame[47] = QuestLogScrollFrameButton47
  flourishQuestLogFrame[48] = QuestLogScrollFrameButton48
  flourishQuestLogFrame[49] = QuestLogScrollFrameButton49
  flourishQuestLogFrame[50] = QuestLogScrollFrameButton50
  flourishQuestLogFrame[51] = QuestLogScrollFrameButton51
  flourishQuestLogFrame[52] = QuestLogScrollFrameButton52
  flourishQuestLogFrame[53] = QuestLogScrollFrameButton53
  flourishQuestLogFrame[54] = QuestLogScrollFrameButton54
  flourishQuestLogFrame[55] = QuestLogScrollFrameButton55
  flourishQuestLogFrame[56] = QuestLogScrollFrameButton56
  flourishQuestLogFrame[57] = QuestLogScrollFrameButton57
  flourishQuestLogFrame[58] = QuestLogScrollFrameButton58
  flourishQuestLogFrame[59] = QuestLogScrollFrameButton59
  flourishQuestLogFrame[60] = QuestLogScrollFrameButton60
end

function flourishQuestGuruVariables()
  flourishQuestLogFrame[1] = QuestGuru_QuestLogTitle1
  flourishQuestLogFrame[2] = QuestGuru_QuestLogTitle2
  flourishQuestLogFrame[3] = QuestGuru_QuestLogTitle3
  flourishQuestLogFrame[4] = QuestGuru_QuestLogTitle4
  flourishQuestLogFrame[5] = QuestGuru_QuestLogTitle5
  flourishQuestLogFrame[6] = QuestGuru_QuestLogTitle6
  flourishQuestLogFrame[7] = QuestGuru_QuestLogTitle7
  flourishQuestLogFrame[8] = QuestGuru_QuestLogTitle8
  flourishQuestLogFrame[9] = QuestGuru_QuestLogTitle9
  flourishQuestLogFrame[10] = QuestGuru_QuestLogTitle10
  flourishQuestLogFrame[11] = QuestGuru_QuestLogTitle11
  flourishQuestLogFrame[12] = QuestGuru_QuestLogTitle12
  flourishQuestLogFrame[13] = QuestGuru_QuestLogTitle13
  flourishQuestLogFrame[14] = QuestGuru_QuestLogTitle14
  flourishQuestLogFrame[15] = QuestGuru_QuestLogTitle15
  flourishQuestLogFrame[16] = QuestGuru_QuestLogTitle16
  flourishQuestLogFrame[17] = QuestGuru_QuestLogTitle17
  flourishQuestLogFrame[18] = QuestGuru_QuestLogTitle18
  flourishQuestLogFrame[19] = QuestGuru_QuestLogTitle19
  flourishQuestLogFrame[20] = QuestGuru_QuestLogTitle20
  flourishQuestLogFrame[21] = QuestGuru_QuestLogTitle21
  flourishQuestLogFrame[22] = QuestGuru_QuestLogTitle22
  flourishQuestLogFrame[23] = QuestGuru_QuestLogTitle23
  flourishQuestLogFrame[24] = QuestGuru_QuestLogTitle24
  flourishQuestLogFrame[25] = QuestGuru_QuestLogTitle25
  flourishQuestLogFrame[26] = QuestGuru_QuestLogTitle26
  flourishQuestLogFrame[27] = QuestGuru_QuestLogTitle27
  flourishQuestLogFrame[28] = QuestGuru_QuestLogTitle28
  flourishQuestLogFrame[29] = QuestGuru_QuestLogTitle29
  flourishQuestLogFrame[30] = QuestGuru_QuestLogTitle30
  flourishQuestLogFrame[31] = QuestGuru_QuestLogTitle31
  flourishQuestLogFrame[32] = QuestGuru_QuestLogTitle32
  flourishQuestLogFrame[33] = QuestGuru_QuestLogTitle33
  flourishQuestLogFrame[34] = QuestGuru_QuestLogTitle34
  flourishQuestLogFrame[35] = QuestGuru_QuestLogTitle35
  flourishQuestLogFrame[36] = QuestGuru_QuestLogTitle36
  flourishQuestLogFrame[37] = QuestGuru_QuestLogTitle37
  flourishQuestLogFrame[38] = QuestGuru_QuestLogTitle38
  flourishQuestLogFrame[39] = QuestGuru_QuestLogTitle39
  flourishQuestLogFrame[40] = QuestGuru_QuestLogTitle40
  flourishQuestLogFrame[41] = QuestGuru_QuestLogTitle41
  flourishQuestLogFrame[42] = QuestGuru_QuestLogTitle42
  flourishQuestLogFrame[43] = QuestGuru_QuestLogTitle43
  flourishQuestLogFrame[44] = QuestGuru_QuestLogTitle44
  flourishQuestLogFrame[45] = QuestGuru_QuestLogTitle45
  flourishQuestLogFrame[46] = QuestGuru_QuestLogTitle46
  flourishQuestLogFrame[47] = QuestGuru_QuestLogTitle47
  flourishQuestLogFrame[48] = QuestGuru_QuestLogTitle48
  flourishQuestLogFrame[49] = QuestGuru_QuestLogTitle49
  flourishQuestLogFrame[50] = QuestGuru_QuestLogTitle50
  flourishQuestLogFrame[51] = QuestGuru_QuestLogTitle51
  flourishQuestLogFrame[52] = QuestGuru_QuestLogTitle52
  flourishQuestLogFrame[53] = QuestGuru_QuestLogTitle53
  flourishQuestLogFrame[54] = QuestGuru_QuestLogTitle54
  flourishQuestLogFrame[55] = QuestGuru_QuestLogTitle55
  flourishQuestLogFrame[56] = QuestGuru_QuestLogTitle56
  flourishQuestLogFrame[57] = QuestGuru_QuestLogTitle57
  flourishQuestLogFrame[58] = QuestGuru_QuestLogTitle58
  flourishQuestLogFrame[59] = QuestGuru_QuestLogTitle59
  flourishQuestLogFrame[60] = QuestGuru_QuestLogTitle60
end

function flourishUberQuestVariables()
  flourishQuestLogFrame[1] = UberQuest_List_Title1
  flourishQuestLogFrame[2] = UberQuest_List_Title2
  flourishQuestLogFrame[3] = UberQuest_List_Title3
  flourishQuestLogFrame[4] = UberQuest_List_Title4
  flourishQuestLogFrame[5] = UberQuest_List_Title5
  flourishQuestLogFrame[6] = UberQuest_List_Title6
  flourishQuestLogFrame[7] = UberQuest_List_Title7
  flourishQuestLogFrame[8] = UberQuest_List_Title8
  flourishQuestLogFrame[9] = UberQuest_List_Title9
  flourishQuestLogFrame[10] = UberQuest_List_Title10
  flourishQuestLogFrame[11] = UberQuest_List_Title11
  flourishQuestLogFrame[12] = UberQuest_List_Title12
  flourishQuestLogFrame[13] = UberQuest_List_Title13
  flourishQuestLogFrame[14] = UberQuest_List_Title14
  flourishQuestLogFrame[15] = UberQuest_List_Title15
  flourishQuestLogFrame[16] = UberQuest_List_Title16
  flourishQuestLogFrame[17] = UberQuest_List_Title17
  flourishQuestLogFrame[18] = UberQuest_List_Title18
  flourishQuestLogFrame[19] = UberQuest_List_Title19
  flourishQuestLogFrame[20] = UberQuest_List_Title20
  flourishQuestLogFrame[21] = UberQuest_List_Title21
  flourishQuestLogFrame[22] = UberQuest_List_Title22
  flourishQuestLogFrame[23] = UberQuest_List_Title23
  flourishQuestLogFrame[24] = UberQuest_List_Title24
  flourishQuestLogFrame[25] = UberQuest_List_Title25
  flourishQuestLogFrame[26] = UberQuest_List_Title26
  flourishQuestLogFrame[27] = UberQuest_List_Title27
  flourishQuestLogFrame[28] = UberQuest_List_Title28
  flourishQuestLogFrame[29] = UberQuest_List_Title29
  flourishQuestLogFrame[30] = UberQuest_List_Title30
  flourishQuestLogFrame[31] = UberQuest_List_Title31
  flourishQuestLogFrame[32] = UberQuest_List_Title32
  flourishQuestLogFrame[33] = UberQuest_List_Title33
  flourishQuestLogFrame[34] = UberQuest_List_Title34
  flourishQuestLogFrame[35] = UberQuest_List_Title35
  flourishQuestLogFrame[36] = UberQuest_List_Title36
  flourishQuestLogFrame[37] = UberQuest_List_Title37
  flourishQuestLogFrame[38] = UberQuest_List_Title38
  flourishQuestLogFrame[39] = UberQuest_List_Title39
  flourishQuestLogFrame[40] = UberQuest_List_Title40
  flourishQuestLogFrame[41] = UberQuest_List_Title41
  flourishQuestLogFrame[42] = UberQuest_List_Title42
  flourishQuestLogFrame[43] = UberQuest_List_Title43
  flourishQuestLogFrame[44] = UberQuest_List_Title44
  flourishQuestLogFrame[45] = UberQuest_List_Title45
  flourishQuestLogFrame[46] = UberQuest_List_Title46
  flourishQuestLogFrame[47] = UberQuest_List_Title47
  flourishQuestLogFrame[48] = UberQuest_List_Title48
  flourishQuestLogFrame[49] = UberQuest_List_Title49
  flourishQuestLogFrame[50] = UberQuest_List_Title50
  flourishQuestLogFrame[51] = UberQuest_List_Title51
  flourishQuestLogFrame[52] = UberQuest_List_Title52
  flourishQuestLogFrame[53] = UberQuest_List_Title53
  flourishQuestLogFrame[54] = UberQuest_List_Title54
  flourishQuestLogFrame[55] = UberQuest_List_Title55
  flourishQuestLogFrame[56] = UberQuest_List_Title56
  flourishQuestLogFrame[57] = UberQuest_List_Title57
  flourishQuestLogFrame[58] = UberQuest_List_Title58
  flourishQuestLogFrame[59] = UberQuest_List_Title59
  flourishQuestLogFrame[60] = UberQuest_List_Title60
end